#include "api.h"
#include "rand.h"
#include <string.h>

//Alice send: generate pk and sk, and send pk to Bob
int kex_alice_send(unsigned char *pk,unsigned char *sk)
{
	//check pointer
	if(pk==NULL || sk==NULL)
	{
		return  -1;
	}
	//call key generation algorithm to get pk and sk
	kg(pk, sk);
	
	return 0;
}
// Bob receive: receive  pk, randomly choose m, and encryrpt m with pk to generate c, k=HASH(pk,m).
int kex_bob_receive(unsigned char *pk, unsigned char *c, unsigned char *k)
{
	unsigned char temp_key[MESSAGE_LEN];
	unsigned char in[MESSAGE_LEN+PK_LEN];
	unsigned long long clen;
	//check pointer
	if(pk==NULL || c==NULL || k==NULL)
	{
		return  -1;
	}
	
	//call cpa secure kem to generate k2 
	random_bytes(temp_key,MESSAGE_LEN);
	enc(pk,temp_key,MESSAGE_LEN,c,&clen);
	
	//call hash to compute  k=hash(pk,m)
	memcpy(in,pk,PK_LEN);
	memcpy(in+PK_LEN,temp_key,MESSAGE_LEN);
	hash_to_k(in,MESSAGE_LEN+PK_LEN,k);
	
	return 0;
}
//Alice receive: receive c, and decrypt to get m and comute k=HASH(pk,m)
int kex_alice_receive(unsigned char *pk, unsigned char *sk, unsigned char *c, unsigned char *k)
{
	unsigned char temp_key[MESSAGE_LEN];
	unsigned char in[MESSAGE_LEN+PK_LEN];
	unsigned long long mlen;
	//check pointer
	if(pk==NULL || sk==NULL || c==NULL || k==NULL)
	{
		return  -1;
	}
	//decrypt c of cca kem to get k2
	dec(sk,c,CIPHER_LEN,temp_key,&mlen);
	
	//call hash to compute  k=hash(pk,m)
	memcpy(in,pk,PK_LEN);
	memcpy(in+PK_LEN,temp_key,MESSAGE_LEN);
	hash_to_k(in,MESSAGE_LEN+PK_LEN,k);
	
	return 0;
}